#include "draw.h"


void hline( SDL_Surface * s, Sint32 x1, Sint32 x2, Sint32 y, Uint32 c )
{
	if( x1 > x2 )
		return;
	if( y >= 0 && y < s->h ){
		x1 = ( x1 >= 0 ? x1 : 0 );
		x2 = ( x2 < s->w ? x2 : s->w - 1 );
		for( Sint32 x = x1; x <= x2; x++ )  // TODO memfill this
			pset(s, x, y, c);
	}
}


void circle( SDL_Surface * s, Sint32 x, Sint32 y, Sint32 r, Uint32 c )
{
	int dx;
	for( Sint32 iy = y - abs(r); iy < y + abs(r); iy++ )
		if( iy >= 0 && iy < s->h ){
			dx = (int)floor(sqrt(fabs( r * r - (y - iy) * (y - iy) )));
			if( r < 0 ) // fill
				hline( s, x - dx, x + dx, iy, c );
			else{ // outline
				pset( s, x - dx, iy, c );
				pset( s, x + dx, iy, c );
			}
		}
}
